"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var completion_template_handler_1 = require("../handler/completion-template-handler");
var AutoCompleteEvent = /** @class */ (function () {
    function AutoCompleteEvent(rule, editor) {
        this.rule = rule;
        this.editor = editor;
        this._allowChildrenToConsumeEvent = true;
        this.completionTemplateHandler = new completion_template_handler_1.CompletionTemplateHandler(this.editor);
    }
    AutoCompleteEvent.prototype.stopPropagation = function () {
        this._allowChildrenToConsumeEvent = false;
    };
    AutoCompleteEvent.prototype.showCompletions = function (completions) {
        var _this = this;
        completions = completions.map(function (completion) {
            if (completion.range === undefined) {
                var newCompletion = _this.editor.createRuleCompletion(completion, _this.rule);
                return _this.completionTemplateHandler.processCompletion(_this.editor.createRuleCompletion(completion, _this.rule));
            }
            else {
                return _this.completionTemplateHandler.processCompletion(completion);
            }
        });
        return this.editor.showCompletions(completions);
    };
    Object.defineProperty(AutoCompleteEvent.prototype, "allowChildrenToConsumeEvent", {
        get: function () {
            return this._allowChildrenToConsumeEvent;
        },
        enumerable: true,
        configurable: true
    });
    return AutoCompleteEvent;
}());
exports.AutoCompleteEvent = AutoCompleteEvent;
